Hooks:PreHook(SkillTreeGui, 'mouse_double_click', 'PerkDeckMixer_SkillTreeGui_mouse_double_click_pre',
function(self, o, button, x, y)
	if self._is_skilltree_page_active then return end
	if not self._mouse_click or not self._mouse_click[0] or not self._mouse_click[1] then return end
	if self._mouse_click[0].selected_tree ~= self._mouse_click[1].selected_tree then return end
	if not self._mouse_click[1].selected_tree or not self._spec_tree_items[self._mouse_click[1].selected_tree]:panel():inside(x, y) then return end
	if managers.system_menu and managers.system_menu:is_active() and not managers.system_menu:is_closing() then return end
	self._mixer_double_click = false
	local tree = self._mouse_click[0].selected_tree
	if tweak_data.skilltree.specializations[tree].name_id == 'perk_deck_mix_name' then
		local dlc = tweak_data:get_raw_value('skilltree', 'specializations', tree, 'dlc') 
		if (dlc and not managers.dlc:is_dlc_unlocked(dlc)) or tree == managers.skilltree:digest_value(managers.skilltree._global.specializations.current_specialization) then
			self._mixer_double_click = true
		end
	end 
end)

Hooks:PostHook(SkillTreeGui, 'mouse_double_click', 'PerkDeckMixer_SkillTreeGui_mouse_double_click_post',
function(self, o, button, x, y)
	if self._is_skilltree_page_active then return end
	if not self._mouse_click or not self._mouse_click[0] or not self._mouse_click[1] then return end
	if self._mouse_click[0].selected_tree ~= self._mouse_click[1].selected_tree then return end
	if not self._mouse_click[1].selected_tree or not self._spec_tree_items[self._mouse_click[1].selected_tree]:panel():inside(x, y) then return end
	if managers.system_menu and managers.system_menu:is_active() and not managers.system_menu:is_closing() then return end
	local tree = self._mouse_click[0].selected_tree
	if tweak_data.skilltree.specializations[tree].name_id == 'perk_deck_mix_name' then
		local dlc = tweak_data:get_raw_value('skilltree', 'specializations', tree, 'dlc') 
		if self._mixer_double_click and ((dlc and not managers.dlc:is_dlc_unlocked(dlc)) or tree == managers.skilltree:digest_value(managers.skilltree._global.specializations.current_specialization)) then
			function cb(input) managers.skilltree:mix_perk_decks(input) end
			local default = ''
			local file = io.open(SavePath .. 'perk_deck_mixer.txt', 'r')
			if file then
				default = file:read('a')
				file:close()
			end
			QuickKeyboardInput:new('Perk Deck Mixer', 'For each perk enter the corresponding perk deck index (as shown in the tab menu) separated by a comma:', default, cb, 26, true)
		end
	end 
end)

function SpecializationTabItem:init(spec_tabs_panel, tree, data, w, x)
	SpecializationTabItem.super.init(self)
	self._data = data
	self._tree = tree
	self._spec_tab = spec_tabs_panel:panel({
		name = tostring(tree),
		w = w,
		x = x
	})
	self._name_string = data.name_id and managers.localization:text(data.name_id) or "NO_NAME_" .. tostring(tree)
	self._desc_string = data.desc_id and managers.localization:text(data.desc_id) or "NO_DESC_" .. tostring(tree)
	if data and data.dlc and tweak_data.lootdrop.global_values[data.dlc] then
		self._desc_string = self._desc_string .. "\n\n" .. "##" .. managers.localization:to_upper_text(tweak_data.lootdrop.global_values[data.dlc].desc_id) .. "##"
		self._desc_custom_color = tweak_data.lootdrop.global_values[data.dlc].color
	end
	self._spec_tab:text({
		word_wrap = false,
		name = "spec_tab_name",
		vertical = "center",
		wrap = false,
		align = "center",
		layer = 1,
		text = utf8.to_upper(self._name_string) .. ' ' .. tostring(#spec_tabs_panel:children()),
		font = tweak_data.menu.pd2_medium_font,
		font_size = tweak_data.menu.pd2_medium_font_size,
		color = tweak_data.screen_colors.button_stage_3
	})
	local _, _, tw, th = self._spec_tab:child("spec_tab_name"):text_rect()
	self._spec_tab:set_size(tw + 15, th + 10)
	self._spec_tab:child("spec_tab_name"):set_size(self._spec_tab:size())
	self._spec_tab:bitmap({
		texture = "guis/textures/pd2/shared_tab_box",
		name = "spec_tab_select_rect",
		visible = false,
		layer = 0,
		w = self._spec_tab:w(),
		h = self._spec_tab:h(),
		color = tweak_data.screen_colors.text
	})
	self._spec_tab:move(0, 0)
end