_G.perk_deck_mixer_loaded = false

Hooks:PreHook(SkillTreeManager, 'get_specialization_value', 'PerkDeckMixer_SkillTreeManager_get_specialization_value',
function(self)
	if not _G.perk_deck_mixer_loaded then
		_G.perk_deck_mixer_loaded = true
		local input = ''
		local file = io.open(SavePath .. 'perk_deck_mixer.txt', 'r')
		if file then
			input = file:read('a')
			file:close()
		end
		local setup = tweak_data.skilltree.specializations[managers.skilltree:digest_value(managers.skilltree._global.specializations.current_specialization)].name_id ~= 'perk_deck_mix_name'
		self:mix_perk_decks(input, setup)
	end
end)

function SkillTreeManager:mix_perk_decks(input, setup)
	local mixer_deck = 1
	for tree, data in ipairs(tweak_data.skilltree.specializations) do
		local trees_mixed = string.split(input, ',')
		if #trees_mixed ~= 9 then return end
		if data.name_id == 'perk_deck_mix_name' then
			mixer_deck = tree
			if not setup then self:set_current_specialization(1) end
			tweak_data.skilltree.specializations[tree].dlc = nil
			tweak_data.upgrades.specialization_descs[tree] = {}
			for tier, tree_mix in ipairs(trees_mixed) do
				tree_mix = tonumber(tree_mix)
				if tree_mix == nil or tree == tree_mix or tree_mix > #tweak_data.skilltree.specializations then return end
				local tier_unlocked = 0
				if self._global.specializations[tree_mix] then
					tier_unlocked = self:digest_value(self._global.specializations[tree_mix].tiers.current_tier)
				end
				if tweak_data.skilltree.specializations[tree_mix].dlc then
					tweak_data.skilltree.specializations[tree].dlc = tweak_data.skilltree.specializations[tree_mix].dlc
				end
				if tier_unlocked >= tier then
					if tweak_data.skilltree.specializations[tree_mix][tier].texture_bundle_folder then
						tweak_data.skilltree.specializations[tree][tier].texture_bundle_folder = tweak_data.skilltree.specializations[tree_mix][tier].texture_bundle_folder
					else
						tweak_data.skilltree.specializations[tree][tier].texture_bundle_folder = nil
					end
					tweak_data.skilltree.specializations[tree][tier].desc_id = tweak_data.skilltree.specializations[tree_mix][tier].desc_id
					tweak_data.skilltree.specializations[tree][tier].name_id = tweak_data.skilltree.specializations[tree_mix][tier].name_id
					tweak_data.skilltree.specializations[tree][tier].upgrades = clone(tweak_data.skilltree.specializations[tree_mix][tier].upgrades)
					tweak_data.skilltree.specializations[tree][tier].icon_xy = clone(tweak_data.skilltree.specializations[tree_mix][tier].icon_xy)
					if tweak_data.upgrades.specialization_descs[tree_mix] then
						tweak_data.upgrades.specialization_descs[tree][tier] = clone(tweak_data.upgrades.specialization_descs[tree_mix][tier])
					end	
				else
					tweak_data.skilltree.specializations[tree][tier].texture_bundle_folder = nil
					tweak_data.skilltree.specializations[tree][tier].desc_id = 'perk_empty_desc'
					tweak_data.skilltree.specializations[tree][tier].name_id = 'perk_empty_name'
					tweak_data.skilltree.specializations[tree][tier].upgrades = {}
					tweak_data.skilltree.specializations[tree][tier].icon_xy = {-1, -1}
				end
			end	
		end
	end
	if not setup then self:set_current_specialization(mixer_deck) end
	local file = io.open(SavePath .. 'perk_deck_mixer.txt', 'w+')
	if file then
		file:write(input)
		file:close()
	end
	if managers.menu_component and managers.menu_component._skilltree_gui then
		local node = managers.menu_component._skilltree_gui._node
		managers.menu_component:close_skilltree_gui()
		managers.menu_component:create_skilltree_gui(node)
	end
end

function SkillTreeManager:set_current_specialization(tree)
	local current_specialization = self:digest_value(self._global.specializations.current_specialization, false, 1)
	if current_specialization == tree then
		return
	end
	local dlc = tweak_data:get_raw_value("skilltree", "specializations", tree, "dlc")
	if dlc and not managers.dlc:is_dlc_unlocked(dlc) then
		return
	end
	local tree_data = self._global.specializations[current_specialization]
	if tree_data then
		local tier_data = tree_data.tiers
		if tier_data then
			local current_tier = self:digest_value(tier_data.current_tier, false)
			local specialization_tweak = tweak_data.skilltree.specializations[current_specialization]
			for i = 1, current_tier do
				for _, upgrade in ipairs(specialization_tweak[i].upgrades) do
					if tweak_data.skilltree.specializations[current_specialization].name_id == 'perk_deck_mix_name' then
						managers.upgrades:unaquire_mixed(upgrade, UpgradesManager.AQUIRE_STRINGS[3] .. tostring(current_specialization))
					else
						managers.upgrades:unaquire(upgrade, UpgradesManager.AQUIRE_STRINGS[3] .. tostring(current_specialization))
					end
				end
			end
		end
	end
	local tree_data = self._global.specializations[tree]
	if not tree_data then
		return
	end
	local tier_data = tree_data.tiers
	if not tier_data then
		return
	end
	self._global.specializations.current_specialization = self:digest_value(tree, true)
	local current_tier = self:digest_value(tier_data.current_tier, false)
	local specialization_tweak = tweak_data.skilltree.specializations[tree]
	for i = 1, current_tier do
		for _, upgrade in ipairs(specialization_tweak[i].upgrades) do
			if tweak_data.skilltree.specializations[tree].name_id == 'perk_deck_mix_name' then
				managers.upgrades:aquire_mixed(upgrade, false, UpgradesManager.AQUIRE_STRINGS[3] .. tostring(tree))
			else
				managers.upgrades:aquire(upgrade, false, UpgradesManager.AQUIRE_STRINGS[3] .. tostring(tree))
			end	
		end
	end
	if self._global.skill_switches[self._global.selected_skill_switch] then
		self._global.skill_switches[self._global.selected_skill_switch].specialization = self._global.specializations.current_specialization
	end
	self:_check_achievements()
	MenuCallbackHandler:_update_outfit_information()
	if SystemInfo:distribution() == Idstring("STEAM") then
		managers.statistics:publish_skills_to_steam()
	end
	return true
end