tweak_data.upgrades_mixed = {}
tweak_data.upgrades_mixed.values = {}

function PlayerManager:calculate_scaling_upgrades(upgrade)
	if not tweak_data.upgrades_mixed.values[upgrade.category] then tweak_data.upgrades_mixed.values[upgrade.category] = {} end
	if not tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade] then tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade] = {} end
	if tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][upgrade.value] == nil then
		tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade][upgrade.value] = nil
		return
	end
	if type(tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][upgrade.value]) ~= 'number' then
		return
	end
	local increasing = true
	local last = nil
	for _, skill in ipairs(tweak_data.upgrades.values[upgrade.category][upgrade.upgrade]) do
		if last and skill < last then increasing = false end
		if not last then last = skill end
	end
	if not tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].base_value then
		if increasing then
			tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].base_value = math.modf(tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][1])
		else
			tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].base_value = 1
		end
	end
	if not tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value then
		tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value = tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].base_value
	end
	if upgrade.value > 1 then
		if increasing then
			tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value = tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value + (tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][upgrade.value] - tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][upgrade.value - 1])
		else
			tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value = tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value - (tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][upgrade.value - 1] - tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][upgrade.value])
		end
	else
		if not tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].first_level then
			tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value = tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][upgrade.value]
			tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].first_level = true
		else
			if increasing then
				tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value = tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value + (tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][upgrade.value] - tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].base_value)
			else
				tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value = tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value - (tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].base_value - tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][upgrade.value])
			end
		end
	end
end

function PlayerManager:aquire_upgrade_mixed(upgrade)
	self:calculate_scaling_upgrades(upgrade)
	self._global.upgrades[upgrade.category] = self._global.upgrades[upgrade.category] or {}
	self._global.upgrades[upgrade.category][upgrade.upgrade] = math.max(upgrade.value, self._global.upgrades[upgrade.category][upgrade.upgrade] or 0)
	local value = tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][upgrade.value]
	if upgrade.synced then
		self._global.synced_upgrades[upgrade.category] = self._global.synced_upgrades[upgrade.category] or {}
		self._global.synced_upgrades[upgrade.category][upgrade.upgrade] = true
	end
	if self[upgrade.upgrade] then
		self[upgrade.upgrade](self, value)
	end
end

function PlayerManager:unaquire_upgrade_mixed(upgrade)
	if not self._global.upgrades[upgrade.category] then
		return
	end
	if not self._global.upgrades[upgrade.category][upgrade.upgrade] then
		return
	end
	if upgrade.category == "player" and upgrade.upgrade == "second_deployable" then
		self:set_equipment_in_slot(nil, 2)
	end
	if type(tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade]) == 'table' then
		tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].base_value = nil
		tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].scaled_value = nil
		tweak_data.upgrades_mixed.values[upgrade.category][upgrade.upgrade].first_level = nil
	end
	local val = self._global.upgrades[upgrade.category][upgrade.upgrade]
	val = 0
	self._global.upgrades[upgrade.category][upgrade.upgrade] = val > 0 and val or nil
	local value = nil
	if self._global.upgrades[upgrade.category][upgrade.upgrade] then
		value = tweak_data.upgrades.values[upgrade.category][upgrade.upgrade][self._global.upgrades[upgrade.category][upgrade.upgrade]]
	elseif upgrade.synced and self._global.synced_upgrades[upgrade.category] then
		self._global.synced_upgrades[upgrade.category][upgrade.upgrade] = nil
	end
	if self[upgrade.upgrade] then
		self[upgrade.upgrade](self, value)
	end
end

function PlayerManager:upgrade_value(category, upgrade, default)
	if not self._global.upgrades[category] then
		return default or 0
	end
	if not self._global.upgrades[category][upgrade] then
		return default or 0
	end
	local level = self._global.upgrades[category][upgrade]
	local value = tweak_data.upgrades.values[category][upgrade][level]
	if tweak_data.skilltree.specializations[managers.skilltree:digest_value(managers.skilltree._global.specializations.current_specialization)].name_id == 'perk_deck_mix_name' and category == 'player' and type(value) == 'number' then
		if tweak_data.upgrades_mixed.values[category] and tweak_data.upgrades_mixed.values[category][upgrade] then
			if tweak_data.upgrades_mixed.values[category][upgrade].scaled_value then
				value = tweak_data.upgrades_mixed.values[category][upgrade].scaled_value
			end
		end
	end
	return value or value ~= false and (default or 0) or false
end